# generated by datamodel-codegen:
#   filename:  entity/services/connections/database/greenplumConnection.json
#   timestamp: 2024-01-25T09:40:49+00:00

from __future__ import annotations

from enum import Enum
from typing import Optional, Union

from pydantic import BaseModel, Extra, Field

from .....security.ssl import verifySSLConfig
from .. import connectionBasicType
from .common import basicAuth, iamAuthConfig


class SslMode(Enum):
    disable = 'disable'
    allow = 'allow'
    prefer = 'prefer'
    require = 'require'
    verify_ca = 'verify-ca'
    verify_full = 'verify-full'


class GreenplumType(Enum):
    Greenplum = 'Greenplum'


class GreenplumScheme(Enum):
    postgresql_psycopg2 = 'postgresql+psycopg2'


class GreenplumConnection(BaseModel):
    class Config:
        extra = Extra.forbid

    type: Optional[GreenplumType] = Field(
        GreenplumType.Greenplum, description='Service Type', title='Service Type'
    )
    scheme: Optional[GreenplumScheme] = Field(
        GreenplumScheme.postgresql_psycopg2,
        description='SQLAlchemy driver scheme options.',
        title='Connection Scheme',
    )
    username: str = Field(
        ...,
        description='Username to connect to Greenplum. This user should have privileges to read all the metadata in Greenplum.',
        title='Username',
    )
    authType: Optional[
        Union[basicAuth.BasicAuth, iamAuthConfig.IamAuthConfigurationSource]
    ] = Field(
        None, description='Choose Auth Config Type.', title='Auth Configuration Type'
    )
    hostPort: str = Field(
        ..., description='Host and port of the source service.', title='Host and Port'
    )
    database: str = Field(
        ...,
        description='Database of the data source. This is optional parameter, if you would like to restrict the metadata reading to a single database. When left blank, OpenMetadata Ingestion attempts to scan all the databases.',
        title='Database',
    )
    sslMode: Optional[SslMode] = Field(
        SslMode.disable,
        description='SSL Mode to connect to Greenplum database.',
        title='SSL Mode',
    )
    sslConfig: Optional[verifySSLConfig.SslConfig] = None
    ingestAllDatabases: Optional[bool] = Field(
        False,
        description='Ingest data from all databases in Greenplum. You can use databaseFilterPattern on top of this.',
        title='Ingest All Databases',
    )
    connectionOptions: Optional[connectionBasicType.ConnectionOptions] = Field(
        None, title='Connection Options'
    )
    connectionArguments: Optional[connectionBasicType.ConnectionArguments] = Field(
        None, title='Connection Arguments'
    )
    supportsMetadataExtraction: Optional[
        connectionBasicType.SupportsMetadataExtraction
    ] = Field(None, title='Supports Metadata Extraction')
    supportsDBTExtraction: Optional[connectionBasicType.SupportsDBTExtraction] = None
    supportsProfiler: Optional[connectionBasicType.SupportsProfiler] = Field(
        None, title='Supports Profiler'
    )
    supportsDatabase: Optional[connectionBasicType.SupportsDatabase] = Field(
        None, title='Supports Database'
    )
    supportsQueryComment: Optional[connectionBasicType.SupportsQueryComment] = Field(
        None, title='Supports Query Comment'
    )
    sampleDataStorageConfig: Optional[
        connectionBasicType.SampleDataStorageConfig
    ] = Field(None, title='S3 Config for Sample Data')
