# generated by datamodel-codegen:
#   filename:  entity/services/connections/database/mongoDB/mongoDBValues.json
#   timestamp: 2024-01-25T09:40:49+00:00

from __future__ import annotations

from enum import Enum
from typing import Optional

from pydantic import BaseModel, Extra, Field

from metadata.ingestion.models.custom_pydantic import CustomSecretStr

from ... import connectionBasicType


class MongoDBScheme(Enum):
    mongodb = 'mongodb'
    mongodb_srv = 'mongodb+srv'


class MongoConnectionValues(BaseModel):
    class Config:
        extra = Extra.forbid

    scheme: Optional[MongoDBScheme] = Field(
        MongoDBScheme.mongodb,
        description='Mongo connection scheme options.',
        title='Connection Scheme',
    )
    username: Optional[str] = Field(
        None,
        description='Username to connect to MongoDB. This user should have privileges to read all the metadata in MongoDB.',
        title='Username',
    )
    password: Optional[CustomSecretStr] = Field(
        None, description='Password to connect to MongoDB.', title='Password'
    )
    hostPort: str = Field(
        ..., description='Host and port of the MongoDB service.', title='Host and Port'
    )
    connectionOptions: Optional[connectionBasicType.ConnectionOptions] = Field(
        None, title='Connection Options'
    )
